#include "inc_baseitem"

int StartingConditional()
{
    object oAnvil = GetNearestObjectByTag("pAnvilOfWonder");
    object oItem = GetFirstItemInInventory(oAnvil);

    if  (
        !GetIsObjectValid(oItem) ||
        isArmor(oItem) ||
        isWearable(oItem) ||
        isGauntlet(oItem) ||
        isMelee(oItem) ||
        isRanged(oItem) ||
        isThrowing(oItem) ||
        isAmmunition(oItem) ||
        isArcane(oItem)
        ) return FALSE;
    else
    {
        //Make sure an item is on the anvil
        object oItem = GetFirstItemInInventory(oAnvil);
        if (oItem != OBJECT_INVALID)
            {
            //Make sure no extra items are on the anvil
            object oNext = GetNextItemInInventory(oAnvil);
            if (oNext == OBJECT_INVALID)
                {
                //Debug
                int iValue = GetGoldPieceValue(oItem);
                 //Real
                SetLocalObject(GetPCSpeaker(), "MODIFY_ITEM", oItem);
                SetCustomToken(100, GetName(oItem));
                }
            }
        return TRUE;
    }
}
